"use strict"; function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } }'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var chunkAITOWUS2_cjs = require('./chunk-AITOWUS2.cjs');
var chunkC66X5FP6_cjs = require('./chunk-C66X5FP6.cjs');
var child_process = require('child_process');
var fs = require('fs');
var path = require('path');
var promises = require('fs/promises');
var tty = require('tty');
var nodeCrypto = require('crypto');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var fs__default = /*#__PURE__*/_interopDefaultLegacy(fs);
var tty__default = /*#__PURE__*/_interopDefaultLegacy(tty);
var nodeCrypto__default = /*#__PURE__*/_interopDefaultLegacy(nodeCrypto);

// src/node/args.ts
function parseArgs(config = {}) {
  const {
    args = process.argv.slice(1),
    alias = {},
    normalize: normalize2 = chunkAITOWUS2_cjs.toCamelCase,
    booleanArgs = [],
    listArgs = [],
    numberArgs = []
  } = config;
  let nameToAlias = Object.entries(alias).reduce((map, curr) => {
    let [name, values] = curr;
    if (typeof values === "string")
      values = [values];
    for (let value of values) {
      map[normalize2(value)] = normalize2(name);
    }
    return map;
  }, {});
  let opts = {
    _: []
  };
  function setOpt(name, value) {
    if (opts[name] == null) {
      opts[name] = value;
    } else if (typeof opts[name] === "boolean") {
      opts[name] = value;
    } else if (Array.isArray(opts[name])) {
      opts[name].push(value);
    } else {
      opts[name] = [opts[name], value];
    }
  }
  chunkC66X5FP6_cjs.__name(setOpt, "setOpt");
  let argList = [...args];
  let arg;
  while (arg = argList.shift()) {
    let value;
    if (/^--?/.test(arg)) {
      let key = arg.replace(/^--?/, "");
      if (arg.includes("=")) {
        let [name, valuePart] = key.split("=", 2);
        key = name.trim();
        value = valuePart.trim();
      }
      key = normalize2(key);
      key = _nullishCoalesce(nameToAlias[key], () => ( key));
      if (booleanArgs.includes(key)) {
        setOpt(key, true);
      } else {
        value = _nullishCoalesce(_nullishCoalesce(value, () => ( argList.shift())), () => ( ""));
        if (numberArgs.includes(key)) {
          value = Number(_nullishCoalesce(value, () => ( 0)));
        }
        if (listArgs.includes(key)) {
          if (Array.isArray(opts[key])) {
            opts[key].push(value);
          } else {
            opts[key] = [value];
          }
        } else {
          setOpt(key, value);
        }
      }
    } else {
      opts._.push(arg);
    }
  }
  return opts;
}
chunkC66X5FP6_cjs.__name(parseArgs, "parseArgs");
function pbcopy(data) {
  return new Promise(async (resolve6, reject) => {
    const proc = child_process.spawn("pbcopy");
    proc.on("error", (err) => reject(err));
    proc.on("close", () => resolve6(data));
    proc.stdin.write(data);
    proc.stdin.end();
  });
}
chunkC66X5FP6_cjs.__name(pbcopy, "pbcopy");
var log = chunkC66X5FP6_cjs.Logger("zeed:env");
var NEWLINE = "\n";
var RE_INI_KEY_VAL = /^\s*([\w_.-]+)\s*=\s*(.*)?\s*$/;
var RE_NEWLINES = /\\n/g;
var NEWLINES_MATCH = /\n|\r|\r\n/;
function parse(src, options = {}) {
  let obj = {};
  String(src).split(NEWLINES_MATCH).forEach(function(line, idx) {
    const keyValueArr = line.match(RE_INI_KEY_VAL);
    if (keyValueArr != null) {
      const key = keyValueArr[1];
      let val = keyValueArr[2] || "";
      const end = val.length - 1;
      const isDoubleQuoted = val[0] === '"' && val[end] === '"';
      const isSingleQuoted = val[0] === "'" && val[end] === "'";
      if (isSingleQuoted || isDoubleQuoted) {
        val = val.substring(1, end);
        if (isDoubleQuoted) {
          val = val.replace(RE_NEWLINES, NEWLINE);
        }
      } else {
        val = val.trim();
      }
      obj[key] = val;
    } else {
      log.debug(
        `did not match key and value when parsing line ${idx + 1}: ${line}`
      );
    }
  });
  return obj;
}
chunkC66X5FP6_cjs.__name(parse, "parse");
function stringToPath(value, defaultValue = ".") {
  return path.resolve(process.cwd(), _nullishCoalesce(value, () => ( defaultValue)));
}
chunkC66X5FP6_cjs.__name(stringToPath, "stringToPath");
function valueToPath(value, defaultValue = "") {
  if (value == null)
    value = defaultValue;
  return stringToPath(String(value).trim(), defaultValue);
}
chunkC66X5FP6_cjs.__name(valueToPath, "valueToPath");
var toPath = valueToPath;
function setupEnv(options = {}) {
  const dotenvPath = _nullishCoalesce((options == null ? void 0 : options.path), () => ( toPath(_nullishCoalesce((options == null ? void 0 : options.filename), () => ( ".env")))));
  const encoding = _nullishCoalesce((options == null ? void 0 : options.encoding), () => ( "utf8"));
  const debug = (options == null ? void 0 : options.debug) || false;
  if (debug !== true)
    log.level = Infinity /* off */;
  try {
    const parsedEnv = fs__default["default"].existsSync(dotenvPath) ? parse(fs__default["default"].readFileSync(dotenvPath, { encoding }), { debug }) : {};
    const parsedEnvLocal = fs__default["default"].existsSync(dotenvPath + ".local") ? parse(fs__default["default"].readFileSync(dotenvPath + ".local", { encoding }), { debug }) : {};
    const parsed = Object.assign(
      {},
      parsedEnv,
      parsedEnvLocal
    );
    let env = _nullishCoalesce((options == null ? void 0 : options.env), () => ( process.env));
    Object.entries(parsed).forEach(([key, value]) => {
      if (typeof (options == null ? void 0 : options.prefix) === "string") {
        key = (options == null ? void 0 : options.prefix) + key;
      }
      if (!Object.prototype.hasOwnProperty.call(env, key)) {
        if (value != null) {
          log.info(`set env.${key} = ${value}`);
          env[key] = value;
        }
      } else {
        log.debug(`"${key}" is already defined and will not be overwritten`);
      }
    });
    return { parsed };
  } catch (e) {
    log.error(e);
    return { error: e };
  }
}
chunkC66X5FP6_cjs.__name(setupEnv, "setupEnv");
var log2 = chunkC66X5FP6_cjs.Logger("zeed:filestorage");
var FileStorage = class {
  constructor(opt = {}) {
    this.store = {};
    this.fileKeys = void 0;
    this.pretty = false;
    this.dirname = path.resolve(process.cwd(), opt.path || ".fileStorage");
    this.pretty = !!opt.pretty;
    this.extension = _nullishCoalesce(opt.extension, () => ( ".json"));
    if (opt.extension && !this.extension.startsWith(".")) {
      this.extension = "." + this.extension;
    }
    this.extensionLength = this.extension.length;
    this.objectToString = _nullishCoalesce(opt.objectToString, () => ( ((data) => {
      return this.pretty ? JSON.stringify(data, null, 2) : JSON.stringify(data);
    })));
    this.objectFromString = _nullishCoalesce(opt.objectFromString, () => ( ((data) => {
      try {
        return JSON.parse(data);
      } catch (err) {
        log2.warn(`fileStorage parse error '${err}' in`, data);
      }
    })));
    this.keyToFilename = _nullishCoalesce(opt.keyToFilename, () => ( chunkAITOWUS2_cjs.toValidFilename));
  }
  setItem(key, value) {
    this.store[key] = chunkAITOWUS2_cjs.cloneObject(value);
    try {
      const data = this.objectToString(value);
      const path$1 = this.getPath(key);
      fs.mkdirSync(path.dirname(path$1), { recursive: true });
      fs.writeFileSync(path$1, data, "utf8");
    } catch (err) {
      log2.error("setItem error", err);
    }
  }
  getPath(key) {
    return path.resolve(this.dirname, this.keyToFilename(key) + this.extension);
  }
  getBuffer(key) {
    const path = this.getPath(key);
    return Buffer.from(fs.readFileSync(path));
  }
  getItem(key) {
    let value = this.store[key];
    if (value === null)
      return;
    if (value != null) {
      return chunkAITOWUS2_cjs.cloneObject(value);
    }
    try {
      const path = this.getPath(key);
      const data = fs.readFileSync(path, "utf8");
      if (data != null) {
        const value2 = this.objectFromString(data);
        this.store[key] = value2;
        return value2;
      }
    } catch (err) {
      log2.warn("getItem error", err);
      this.store[key] = null;
    }
  }
  removeItem(key) {
    delete this.store[key];
    if (this.fileKeys != null) {
      const index = this.fileKeys.indexOf(key);
      if (index !== -1) {
        this.fileKeys.splice(index, 1);
      }
    }
    try {
      const path = this.getPath(key);
      fs.unlinkSync(path);
    } catch (err) {
    }
  }
  clear() {
    this.fileKeys = [];
    this.store = {};
    fs.rmSync(this.dirname, { recursive: true, force: true });
  }
  allKeys() {
    if (this.fileKeys == null) {
      try {
        this.fileKeys = fs.readdirSync(this.dirname, { withFileTypes: true }).filter(
          (item) => !item.isDirectory() && item.name.endsWith(this.extension)
        ).map((item) => item.name.slice(0, -this.extensionLength)) || [];
      } catch (err) {
      }
    }
    let keys = [...this.fileKeys || []];
    for (let key of Object.keys(this.store)) {
      if (!keys.includes(key)) {
        keys.push(key);
      }
    }
    keys.sort();
    return keys;
  }
};
chunkC66X5FP6_cjs.__name(FileStorage, "FileStorage");
function toHumanReadableFilePath(path$1) {
  const p = path.normalize(path$1);
  const h = process.env.HOME;
  if (h && p.startsWith(h)) {
    return "~" + p.slice(h.length);
  }
  return p;
}
chunkC66X5FP6_cjs.__name(toHumanReadableFilePath, "toHumanReadableFilePath");
async function exists(path) {
  try {
    await promises.stat(path);
  } catch (err) {
    return false;
  }
  return true;
}
chunkC66X5FP6_cjs.__name(exists, "exists");
async function ensureFolder(...parts) {
  const path$1 = path.join(...parts);
  if (!await exists(path$1)) {
    await promises.mkdir(path$1, { recursive: true });
  }
  return path$1;
}
chunkC66X5FP6_cjs.__name(ensureFolder, "ensureFolder");
async function removeFolder(...parts) {
  const path$1 = path.join(...parts);
  if (await exists(path$1)) {
    await promises.rm(path$1, { recursive: true });
  }
  return path$1;
}
chunkC66X5FP6_cjs.__name(removeFolder, "removeFolder");
async function readText(...parts) {
  const path$1 = path.join(...parts);
  if (await exists(path$1)) {
    return await promises.readFile(path$1, "utf-8");
  }
}
chunkC66X5FP6_cjs.__name(readText, "readText");
async function writeText(path, content) {
  await promises.writeFile(path, content, "utf-8");
}
chunkC66X5FP6_cjs.__name(writeText, "writeText");
var namespaces = {};
function LoggerFileHandler(path$1, opt = {}) {
  const { level = -1 /* all */, filter = "*" } = opt;
  path$1 = path.resolve(process.cwd(), path$1);
  fs.mkdirSync(path.dirname(path$1), { recursive: true });
  var stream = fs.createWriteStream(path$1, { flags: "a" });
  const matchesNamespace = chunkC66X5FP6_cjs.useNamespaceFilter(filter);
  const matchesLevel = chunkC66X5FP6_cjs.useLevelFilter(level);
  return (msg) => {
    if (!matchesLevel(msg.level))
      return;
    if (!matchesNamespace(msg.name))
      return;
    const time2 = new Date().toISOString();
    let name = msg.name || "";
    let ninfo = namespaces[name || ""];
    if (ninfo == null) {
      namespaces[name] = ninfo;
    }
    let args = [
      `[${name || "*"}]`,
      chunkAITOWUS2_cjs.renderMessages(msg.messages, { pretty: false })
    ];
    function write(...args2) {
      stream.write(args2.join("	") + "\n");
    }
    chunkC66X5FP6_cjs.__name(write, "write");
    switch (msg.level) {
      case 1 /* info */:
        write(time2, `I|*  `, ...args);
        break;
      case 2 /* warn */:
        write(time2, `W|** `, ...args);
        break;
      case 3 /* error */:
        write(time2, `E|***`, ...args);
        break;
      default:
        write(time2, `D|   `, ...args);
        break;
    }
  };
}
chunkC66X5FP6_cjs.__name(LoggerFileHandler, "LoggerFileHandler");
function getStackLlocationList(stack) {
  var _a2, _b2;
  if (typeof stack !== "string")
    return [];
  return ((_b2 = (_a2 = stack == null ? void 0 : stack.split("\n")) == null ? void 0 : _a2.map((rawLine) => {
    let m = rawLine.match(
      /^\s+at.*(\((.*)\)|file:\/\/(.*)$)|\s*at\s(\/.*)$/
    );
    if (m) {
      let line = m[3] || m[2] || m[4];
      if (line.endsWith(")"))
        line = line.slice(0, -1);
      return line;
    }
  })) == null ? void 0 : _b2.filter((v) => v != null)) || [];
}
chunkC66X5FP6_cjs.__name(getStackLlocationList, "getStackLlocationList");
var cwd = path.resolve(process.cwd());
var _a, _b;
var home = ((_a = process.env) == null ? void 0 : _a.HOME) ? path.resolve((_b = process.env) == null ? void 0 : _b.HOME) : "";
function pathStripCwd(path) {
  if (path.includes("/node_modules/")) {
    return "";
  }
  const fileURL = "file://";
  if (path.startsWith(fileURL)) {
    return path.substr(fileURL.length);
  }
  if (cwd && path.startsWith(cwd)) {
    return path.substr(cwd.length + 1);
  }
  if (home && path.startsWith(home)) {
    path = "~/" + path.substr(home.length + 1);
  }
  return path;
}
chunkC66X5FP6_cjs.__name(pathStripCwd, "pathStripCwd");
function extractFileInfo(stackLine) {
  let m = stackLine.match(/^\s*at.*(\((.*)\)|file:\/\/(.*)$)|\s*at\s(\/.*)$/);
  if (m) {
    let line = m[3] || m[2] || m[4];
    if (line.endsWith(")"))
      line = line.slice(0, -1);
    return line;
  }
  return "";
}
chunkC66X5FP6_cjs.__name(extractFileInfo, "extractFileInfo");
function getSourceLocation(level = 2, stripCwd = true) {
  var _a2;
  let stack = new Error().stack || "";
  let line = (_a2 = getStackLlocationList(stack)) == null ? void 0 : _a2[level];
  if (line && stripCwd) {
    line = pathStripCwd(line);
  }
  return line || "";
}
chunkC66X5FP6_cjs.__name(getSourceLocation, "getSourceLocation");
function getStack() {
  return new Error().stack || "";
}
chunkC66X5FP6_cjs.__name(getStack, "getStack");
function getSourceLocationByPrecedingPattern(patterns, stripCwd = true) {
  let line = "";
  let stack = new Error().stack || "";
  if (typeof stack === "string") {
    const lines = stack.split("\n").map((l) => l.trim());
    const index = lines.findIndex((l) => patterns.some((p) => l.startsWith(p)));
    line = lines[index + 1];
    if (line) {
      line = extractFileInfo(line);
    }
    if (line && stripCwd) {
      line = pathStripCwd(line);
    }
  }
  return line;
}
chunkC66X5FP6_cjs.__name(getSourceLocationByPrecedingPattern, "getSourceLocationByPrecedingPattern");
function shouldUseColor() {
  try {
    return chunkAITOWUS2_cjs.valueToBoolean(process.env.ZEED_COLOR, tty__default["default"].isatty(process.stdout.fd));
  } catch (err) {
  }
  return false;
}
chunkC66X5FP6_cjs.__name(shouldUseColor, "shouldUseColor");
var defaultUseColor = shouldUseColor();
var colors = [6, 2, 3, 4, 5, 1];
function selectColor(namespace) {
  let hash = 0;
  for (let i = 0; i < namespace.length; i++) {
    hash = (hash << 5) - hash + namespace.charCodeAt(i);
    hash |= 0;
  }
  return colors[Math.abs(hash) % colors.length];
}
chunkC66X5FP6_cjs.__name(selectColor, "selectColor");
var namespaces2 = {};
var time = chunkC66X5FP6_cjs.getTimestamp();
function log3(...args) {
  process.stdout.write(chunkAITOWUS2_cjs.renderMessages(args) + "\n");
}
chunkC66X5FP6_cjs.__name(log3, "log");
var TTY_STYLE = {
  BOLD: "\x1B[1m",
  UNBOLD: "\x1B[2m",
  RED: "\x1B[31m",
  GREEN: "\x1B[32m",
  BLUE: "\x1B[34m",
  PURPLE: "\x1B[35m",
  GRAY: "\x1B[37m",
  ORANGE: "\x1B[38;5;208m",
  UNCOLOR: "\x1B[0m"
};
var colorEnd = "\x1B[0m";
function colorString(value, colorCode) {
  const colorStart = colorCode === 8 /* ORANGE */ ? TTY_STYLE.ORANGE : "\x1B[3" + (colorCode < 8 ? colorCode : "8;5;" + colorCode) + "m";
  return `${colorStart}${value}${colorEnd}`;
}
chunkC66X5FP6_cjs.__name(colorString, "colorString");
function colorStringList(list, style, bold = true) {
  return list.map((value) => {
    if (typeof value !== "string")
      return value;
    let start = style;
    let end = colorEnd;
    if (bold) {
      start = `${TTY_STYLE.BOLD}${start}`;
      end = `${end}${TTY_STYLE.BOLD}`;
    }
    return `${start}${value}${end}`;
  });
}
chunkC66X5FP6_cjs.__name(colorStringList, "colorStringList");
var loggerStackTraceDebug = "loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";
function LoggerNodeHandler(opt = {}) {
  const {
    level = void 0,
    filter = void 0,
    colors: colors2 = defaultUseColor,
    levelHelper = true,
    nameBrackets = true,
    padding = 0,
    fill = 0,
    stack = true
  } = opt;
  const matchesNamespace = chunkC66X5FP6_cjs.useNamespaceFilter(filter);
  const matchesLevel = chunkC66X5FP6_cjs.useLevelFilter(level);
  return (msg) => {
    var _a2;
    if (!matchesLevel(msg.level))
      return;
    if (!matchesNamespace(msg.name))
      return;
    const timeNow = chunkC66X5FP6_cjs.getTimestamp();
    let name = msg.name || "";
    let ninfo = namespaces2[name || ""];
    if (ninfo == null) {
      ninfo = {
        color: selectColor(name)
      };
      namespaces2[name] = ninfo;
    }
    const diff = chunkC66X5FP6_cjs.formatMilliseconds(timeNow - time);
    let args;
    let displayName = nameBrackets ? `[${name}]` : name;
    if (padding > 0) {
      displayName = displayName.padStart(padding, " ");
    }
    if (fill > 0) {
      displayName = displayName.padEnd(fill, " ");
    }
    if (colors2) {
      const c = ninfo.color;
      args = [colorString(displayName, c) + ` | `];
      if (msg.level === 2 /* warn */) {
        args.push(...colorStringList(msg.messages, TTY_STYLE.ORANGE));
      } else if (msg.level === 3 /* error */) {
        args.push(...colorStringList(msg.messages, TTY_STYLE.RED));
      } else {
        args.push(...msg.messages);
      }
      args.push(colorString(`+${diff}`, c));
    } else {
      args = [displayName, ...msg.messages];
      args.push(`+${diff}`);
    }
    if (((_a2 = msg.messages) == null ? void 0 : _a2[0]) === loggerStackTraceDebug) {
      console.log(getStack());
    }
    if (stack) {
      let line = "";
      if (typeof stack === "boolean") {
        line = getSourceLocationByPrecedingPattern(
          ["at Function.", "at null.log (", "at log ("],
          true
        );
        if (!line) {
          line = getSourceLocation(0, true);
        }
      } else {
        const depth = typeof stack === "number" ? stack : 3;
        line = getSourceLocation(depth, true);
      }
      if (line) {
        args.push(colorString(`(${line})`, 7 /* GRAY */));
      }
    }
    const sep = "|";
    const charLevel = ".";
    switch (msg.level) {
      case 1 /* info */:
        if (levelHelper)
          args[0] = `I${sep}${charLevel}   ` + args[0];
        log3(...args);
        break;
      case 2 /* warn */:
        if (levelHelper)
          args[0] = (colors2 ? colorString(`W${sep}${charLevel}${charLevel}  `, 8 /* ORANGE */) : `W${sep}${charLevel}${charLevel}  `) + args[0];
        log3(...args);
        break;
      case 3 /* error */:
        if (levelHelper)
          args[0] = (colors2 ? colorString(
            `E${sep}${charLevel}${charLevel}${charLevel} `,
            1 /* RED */
          ) : `E${sep}${charLevel}${charLevel}${charLevel} `) + args[0];
        log3(...args);
        break;
      default:
        if (levelHelper)
          args[0] = `D${sep}    ` + args[0];
        log3(...args);
        break;
    }
  };
}
chunkC66X5FP6_cjs.__name(LoggerNodeHandler, "LoggerNodeHandler");
try {
  if (nodeCrypto__default["default"] && nodeCrypto__default["default"].webcrypto && typeof globalThis !== "undefined" && typeof globalThis.crypto === "undefined") {
    globalThis.crypto = nodeCrypto__default["default"].webcrypto;
  }
} catch (err) {
  console.warn("Failed to polyfill webcrypto", err);
}

// src/node/log-context-node.ts
function setupLogContextNode() {
  let handlers = [
    LoggerNodeHandler({
      padding: 32,
      nameBrackets: false
    })
  ];
  let logFilePath = _nullishCoalesce(process.env.ZEED_LOG, () => ( process.env.LOG));
  if (logFilePath) {
    handlers.unshift(LoggerFileHandler(toPath(logFilePath)));
  }
  chunkC66X5FP6_cjs.Logger.setHandlers(handlers);
}
chunkC66X5FP6_cjs.__name(setupLogContextNode, "setupLogContextNode");
setupLogContextNode();

exports.FileStorage = FileStorage;
exports.LoggerFileHandler = LoggerFileHandler;
exports.LoggerNodeHandler = LoggerNodeHandler;
exports.colorString = colorString;
exports.colorStringList = colorStringList;
exports.ensureFolder = ensureFolder;
exports.exists = exists;
exports.getSourceLocation = getSourceLocation;
exports.getSourceLocationByPrecedingPattern = getSourceLocationByPrecedingPattern;
exports.getStack = getStack;
exports.getStackLlocationList = getStackLlocationList;
exports.loggerStackTraceDebug = loggerStackTraceDebug;
exports.parseArgs = parseArgs;
exports.pbcopy = pbcopy;
exports.readText = readText;
exports.removeFolder = removeFolder;
exports.setupEnv = setupEnv;
exports.stringToPath = stringToPath;
exports.toHumanReadableFilePath = toHumanReadableFilePath;
exports.toPath = toPath;
exports.valueToPath = valueToPath;
exports.writeText = writeText;
//# sourceMappingURL=chunk-CCZIVE22.cjs.map